package encapsulation.model;

import jst.symtab.*;
import java.util.*;

/**
 * ExecutableBlock class, represents a block of code in the program
 * @author Janina Voigt
 *
 */
public class ExecutableBlock extends Member{

	protected ExecutableCode block;
	
	/**
	 * Constructor for ExecutableBlock objects
	 * @param theOwner the owner class or interface
	 * @param theBlock the JST ExecutableCode corresponding to this block
	 */
	public ExecutableBlock(ClassOrInterface theOwner, ExecutableCode theBlock){
		super(theOwner);
		accesses = new HashSet<Access>();
		block = theBlock;
	}
	
	/**
	 * Gets the JST Decl corresponding to this member
	 * @return the JST Decl
	 */
	public Decl getDecl() {
		return block;
	}
	
}
