package encapsulation.model;

import jst.symtab.*;

/**
 * Field class, represents a field in the program
 * @author Janina Voigt
 *
 */
public class Field extends AccessibleMember {

	protected FieldDecl field;
	
	/**
	 * Constructor for Field objects
	 * @param theOwner the owner class or interface
	 * @param theField the JST FieldDecl corresponding to this field
	 */
	public Field(ClassOrInterface theOwner, FieldDecl theField){
		super(theOwner);
		field = theField;
	}
	
	/**
	 * Gets the JST Decl corresponding to this member
	 * @return the JST Decl
	 */
	public Decl getDecl() {
		return field;
	}
	
	/**
	 * Returns boolean indicating if the field is a method 
	 * @return true if the member is a field, false otherwise
	 */
	public boolean isField() {
		return true;
	}
}
