package jst.app;

import util.*;

public class JSTMessage extends Message {

	public static final JSTMessage OK = new JSTMessage("OK");

	public static final JSTMessage USAGE = new JSTMessage(
			"usage: different from what you did"
    );

	public static final JSTMessage XML_PARSER_ERROR = new JSTMessage("Error parsing XML:");
	public static final JSTMessage NOT_A_PARSETREE = new JSTMessage("Input file is not a parse tree.");

	public static final JSTMessage OPEN_INPUT_FILE = new JSTMessage("Could not open input file:");
	public static final JSTMessage OPEN_OUTPUT_FILE = new JSTMessage("Could not open output file:");

	public static final JSTMessage TYPE_NOT_FOUND = new JSTMessage("Type not found:");
	public static final JSTMessage METHOD_NOT_FOUND = new JSTMessage("Method not found:");
	public static final JSTMessage CONSTRUCTOR_NOT_FOUND = new JSTMessage("Constructor not found:");
	public static final JSTMessage VARIABLE_NOT_FOUND = new JSTMessage("Variable not found:");
	public static final JSTMessage PACKAGE_NOT_FOUND = new JSTMessage("Package not found:");
	public static final JSTMessage PACKAGE_OR_TYPE_NOT_FOUND = new JSTMessage("Class or package not found:");
	public static final JSTMessage PACKAGE_OR_TYPE_OR_VARIABLE_NOT_FOUND = new JSTMessage("Package or type or variable not found:");
	
	public static final JSTMessage TYPE_NOT_A_CLASS = new JSTMessage("Type is not a class:");
	public static final JSTMessage TYPE_NOT_AN_INTERFACE = new JSTMessage("Type is not an interface:");
	public static final JSTMessage TYPE_NOT_ACTUAL_TYPE = new JSTMessage("Type is not an actual type:");
	public static final JSTMessage TYPE_NOT_A_USERTYPE = new JSTMessage("Type is not a usertype:");

    protected JSTMessage(String theText) {
        super(theText);
    }

    public JSTMessage(JSTMessage base, String extra) {
        super(base, extra);
    }

    public JSTMessage(int line, int col, JSTMessage theText) {
        super("[" + line + ", " + col + "] " + theText);
    }

    public JSTMessage(int line, int col, JSTMessage base, String extra) {
        super("[" + line + ", " + col + "] " + base + extra);
    }

    public JSTMessage(String fileName, int line, int col, JSTMessage base, String extra) {
        super(fileName + " [" + line + ", " + col + "] " + base + extra);
    }
}
