package jst.symtab;

import java.util.*;

import jst.parsetree.* ;
import jst.symtab.visitor.ModelVisitor;

public class CatchBlock extends Block {
    /**
     * @supplierRole parameter 
     * @link aggregation
     */
	ParameterDecl parameter;

	public CatchBlock(Block theOwner, JstParseTreeBranch theSource) {
    	super(theOwner, theSource);
    }

	public CatchBlock(Block newOwner, CatchBlock that, Map<TypeParameter, ActualType> swaps) {
		super(newOwner, that, swaps);
	}

	public void copy(Block newOwner, Map<TypeParameter, ActualType> swaps) {
		new CatchBlock(newOwner, this, swaps);
	}

	public void setParameter(ParameterDecl theParameter) {
    	parameter = theParameter;
    }

	public ParameterDecl getParameter() {
    	return parameter;
    }

	public VariableDecl lookupVariable(boolean widen, String name, ReferenceType looker) {
    	if (parameter != null && parameter.getSimpleName().equals(name))
        	return parameter;

    	return super.lookupVariable(widen, name, looker);
    }

    public void accept(ModelVisitor visitor) {
        visitor.visitCatchBlock(this);
    }
}
