
package jst.symtab;

import java.util.*;
import java.io.*;

import jst.parsetree.*;
import jst.symtab.visitor.ModelVisitor;

public class LocalVariableDecl extends VariableDecl {

	protected int modifier;

	public LocalVariableDecl(Block ownerBlock, String theSimpleName, JstParseTreeBranch theSource) {
    	super(ownerBlock, theSimpleName, theSource);

    	ownerBlock.addVariable(this);
    }

	public LocalVariableDecl(Block newOwnerBlock, LocalVariableDecl that, Map<TypeParameter, ActualType> swaps) {
		super(newOwnerBlock, that, swaps);

    	newOwnerBlock.addVariable(this);
	}
	
	public void copy(Block newOwnerBlock, Map<TypeParameter, ActualType> swaps) {
		new LocalVariableDecl(newOwnerBlock, this, swaps);
	}

	public String getCanonicalName() {
    	return "LCV_" + getOwnerScope().getCanonicalName().substring(4) + "." + simpleName;
    }

    public void setModifier(int theModifier) {
    	modifier |= theModifier;
    }

    public void accept(ModelVisitor visitor) {
        visitor.visitLocalVariableDecl(this);
    }
}
