package jst.symtab.link;

import jst.app.JSTMessage;
import jst.symtab.*;

public class ArrayLink extends ScopeLink implements ReferenceTypeLink {

	protected TypeLink baseTypeLink;

	public ArrayLink(TypeLink theBaseTypeLink) {

		baseTypeLink = theBaseTypeLink;

		assert baseTypeLink != null;
	}

	public ArrayLink(Decl newOwner, ArrayLink that) {
		baseTypeLink = that.baseTypeLink.copyType(newOwner);
	}

	public ArrayLink copy(Decl newOwner) {
		return new ArrayLink(newOwner, this);
	}

	public ArrayLink copyType(Decl newOwner) {
		return copy(newOwner);
	}

	public boolean isFirst() {
		return false;
	}

	public boolean isInstance() {
		return true; // ToDo: decide if this is OK.
	}

	public Scope getOriginScope() {
		return null; // No need to check if access to an array is legal -- it always is.
	}

	public Scope getScope() {
		return getReferenceType();
	}

	public String getName() {
		return baseTypeLink.getName();
	}

	public int getLine() {
		return baseTypeLink.getLine();
	}

	public int getColumn() {
		return baseTypeLink.getColumn();
	}

	public String getOwnerFileName() {
		return baseTypeLink.getOwnerFileName();
	}

	public String getFullName() {
		return baseTypeLink.getFullName() + "[]";
	}

	public boolean resolve() {
		return baseTypeLink.resolve();
	}

	public JSTMessage getMessage() {
		return baseTypeLink.getMessage();
	}
	public Decl getDecl() {
		return getType();
	}

	public TypeDecl getType() {
		return getActualType();
	}

	public ActualType getActualType() {
		return getReferenceType();
	}

	public ReferenceType getReferenceType() {
		if (baseTypeLink.getType() == null)
			return null;

		return baseTypeLink.getType().getArrayType();
	}
}
