package jst.symtab.link;

import parser.parsetree.SyntaxTreeLeaf;
import jst.symtab.*;
import jst.app.JSTMessage;

public abstract class ScopeLink implements Link {
	
	public abstract boolean isFirst();

	public abstract boolean isInstance();

	protected UserType getLooker() {
		if (getOriginScope() == null)
			return null;

		return getOriginScope().getOwnerUserType();
	}

	protected abstract Scope getOriginScope();

	public abstract Scope getScope();

	public abstract ScopeLink copy(Decl newOwner);

	public String toString() {
		return getOwnerFileName() + ":" + getFullName();
	}

	public SyntaxTreeLeaf getSource() {
		return null;
	}
}
