package jst.symtab.visitor;

import java.util.*;

import jst.app.JSTMessage;
import jst.symtab.*;
import jst.parsetree.*;

public class ImportResolver extends CompositionVisitor {

    protected List<JSTMessage> messages;

    public ImportResolver() {
        messages = new ArrayList<JSTMessage>();
    }

    public void visitPackageDecl(PackageDecl packageDecl) {
        visitKids(packageDecl.getSourceFiles());

		// We may discover new packages being imported.
		// Prevent concurrent mod exception.  (New pkgs will not contain
		// source files, so can be ignored.
		Set<PackageDecl> subPkgs = new HashSet<PackageDecl>(packageDecl.getSubPackages());
        visitKids(subPkgs);
    }

    public void visitSourceFile(SourceFile sourceFile) {
		sourceFile.resolveImports(messages);
    }

	public List getMessages() {
		return messages;
	}
}
