package parser.parsetree.tokenFactory;

import parser.grammar.*;
import parser.parsetree.*;

/** Factory for producing tokens. */
public interface TokenFactory {

    /**
     * Create a token with the given type, value, line and column.
     *
     * @param type the grammar terminal type of this token.
     * @param value the text string for the token.
     * @param line the line on which the token begins.
     * @param column the column on which the token begins.
     * @return a new Token, in a sequence of Tokens.
     */
	public Token makeToken(Terminal type, String value, int line, int column);
}
