package parser.parsetree.treeFactory;

import parser.grammar.*;
import parser.parsetree.*;

import java.util.*;

public class AmbiguousASTFactory extends ASTFactory {

    /**
     * Make an existing node ambiguous.  Checks first whether the alternative is identical.
     *
     * @param existing a parse tree node that may already be in use in a tree.
     * @param alternative an ambiguous alternative that has the same lhs.
     */
	public void makeAmbiguity(AbstractSyntaxTreeBranch existing, AbstractSyntaxTreeBranch alternative) {
        //if (existing.equals(alternative))
        //    return;

        existing.ambiguity(alternative);
    }
}
