package parser.pda.stateMachine;
import java.util.*;
import parser.grammar.*;

public abstract class KLookahead extends AbstractLookahead {

    // Map TerminalSymbol ==> KLookahead
    protected abstract Map getNext();

    public abstract KLookahead grow(Terminal symbol);

    public abstract void addAction(ShiftOrReduce theAction);

    public Set getExpected() {
	    Set result = new HashSet();
        Map next = getNext();

        if (next.isEmpty()) {
            result.add(new LinkedList());
            return result;
        }

        Iterator nextIter = next.entrySet().iterator();
        while (nextIter.hasNext()) {
            Map.Entry entry = (Map.Entry) nextIter.next();
            Terminal Terminal = (Terminal) entry.getKey();
            NondeterministicKLookahead look = (NondeterministicKLookahead) entry.getValue();

            Set kidResult = look.getExpected();
            Iterator kidResIter = kidResult.iterator();
            while (kidResIter.hasNext()) {
                List kidRes = (List) kidResIter.next();
                kidRes.add(0, Terminal);
                result.add(kidRes);
            }
        }

        return result;
	}

    public String toString() {
        String result = "look(";

        Iterator nextIter = getNext().entrySet().iterator();
        while (nextIter.hasNext()) {
            Map.Entry entry = (Map.Entry) nextIter.next();
            Terminal symbol = (Terminal) entry.getKey();
            KLookahead look = (KLookahead) entry.getValue();

            result += " on " + symbol.toString() + " ";
            result += look.toString();
        }

        result += ")";
        return result;
    }
}
