package parser.pda.stateMachine;
import parser.grammar.Production;
import parser.grammar.Symbol;
import java.util.*;

public class NondeterministicStateTable extends StateTable {

    protected int[][] transitions;

	protected Production[][][] reductions;

    protected NondeterministicStateTable(int theStartState, int theStopState) {
        super(theStartState, theStopState);
    }

    public int getTransition(int state, Symbol symbol) {
        return transitions[state][symbol.getID()];
    }

    public Production[] getReductions(int state, Symbol symbol) {
        return reductions[state][symbol.getID()];
    }

    public Set getExpected(int state) {
        Set result = super.getExpected(state);

        for(int i = 1; i < symbols.length; i++) {
            Symbol symbolType = symbols[i];

            if (symbolType.isTerminal() && getReductions(state, symbolType)!= null )
	                result.add(symbolType.toString());
	    }

        return result;
    }
}
