package parser.pda.stateMachine;

import java.util.*;
import parser.grammar.*;
import parser.pda.tokenStream.*;
import parser.pda.*;

public class RunState extends State {

    /**
     * @supplierRole lookahead 
     */
    protected Lookahead lookahead;

    public RunState(Symbol theSymbolType) {
        super(theSymbolType);
        lookahead = null;
    }

    public void addTransition(State dst) {
        Object old = transitions.put(dst.getSymbol(), dst);
        assert old == null : "Duplicate transition from " + this + " on " + dst.getSymbol();
    }

    public void setLookahead(Lookahead theLookahead) {
        lookahead = theLookahead;
    }

    public Lookahead getLookahead() {
        return lookahead;
    }
}
