package parser.pda.stateMachine;
import parser.grammar.Symbol;
import java.util.*;

public abstract class StateTable {

    protected int startState;

    protected int stopState;

    protected Symbol[] symbols; // Just for error reporting.

	protected String[] states; // Just for debugging.

    protected StateTable(int theStartState, int theStopState) {
        startState = theStartState;
        stopState = theStopState;
    }

    public int getStartState() {
        return startState;
    }

    public int getStopState() {
        return stopState;
    }

    public abstract int getTransition(int state, Symbol symbol);

    public Set getExpected(int state) {
        Set result = new TreeSet();

        for(int i = 1; i < symbols.length; i++) {
            Symbol symbolType = symbols[i];

            if (symbolType.isTerminal() && getTransition(state, symbolType) > 0 )
	                result.add(symbolType.toString());
	    }

        return result;
    }

	public String getContext(int state) {
		return states[state];
	}
}
