package parser.pda.stateMachine.builder;

import parser.parsetree.*;
import parser.grammar.*;
import parser.pda.stateMachine.*;
import java.util.*;

public class OneLookaheadBuilder extends LookaheadBuilder {

    protected OneLookahead lookahead;
    protected Terminal on;

    public OneLookaheadBuilder() {
        reset();
    }

    public void reset() {
        lookahead = new OneLookahead();
        on = null;
    }

    public void begin(Terminal theOn) {
        assert on == null;
        on = theOn;
    }

    public void addAction(ShiftOrReduce action) {
        assert on != null;
        lookahead.addAction(on, action);
    }

    public void end() {
        assert on != null;
        on = null;
    }

    public Lookahead getResult(){
        return lookahead;
    }
}
